#include <linux/init.h>
#include <linux/module.h>
#include <linux/kernel.h>
#include <linux/fs.h>
#include <linux/errno.h>
#include <linux/types.h>
#include <linux/fcntl.h>

#define DUMMY_MAJOR_NUMBER 240  /* dummy.c */
#define DEV_NAME "dummy-device"
int dummy_open(struct inode *inode,struct file *filp)
{
	int num=MINOR(inode->i_rdev);
	printk("call open ->minor:%d\n",num);
	return 0;
}
loff_t dummy_llseek(struct file *filp,loff_t off,int whence)
{
	printk("call llseek->off:%08x, whenec:%08x\n",off,whence);
	return 0x23;
}
ssize_t dummy_read(struct file *filp,char *buf, size_t count,loff_t *f_pos)
{
	printk("call read ->buf:%08x, count:%08x\n",buf,count);
	return 0x33;
}
ssize_t dummy_write(struct file *filp,const char *buf, size_t count,loff_t *f_pos)
{
	printk("call write->buf:%08x, count:%08x\n",buf,count);
	return 0x43;
}
int dummy_ioctl(struct inode *inode, struct file *filp,unsigned int cmd,unsigned long arg)
{
	printk("call ioctl->cmd:%08,arg:%08x\n",cmd,arg);
	return 0x53;
}
int dummy_release(struct inode *inode, struct file *filp)
{
	printk("call release\n");
	return 0;
}
struct file_operations dummy_fops = 
{
	.owner =THIS_MODULE,
	.llseek=dummy_llseek,
	.open = dummy_open,	
	.read=dummy_read,
	.write=dummy_write,
	.ioctl=dummy_ioctl,
	.release=dummy_release,

}; 
int dummy_init(void)
{
	int result; 
	printk("call dummy_init\n");
	result=register_chrdev(DUMMY_MAJOR_NUMBER,DEV_NAME,&dummy_fops);
	if(result<0) return result;
	return 0;
} 
void dummy_exit(void)
{ 
	printk("call dummy_exit\n");
	unregister_chrdev(DUMMY_MAJOR_NUMBER,DEV_NAME);
} 
module_init(dummy_init);
module_exit(dummy_exit);

MODULE_LICENSE("GPL");
